﻿$(document).ready(function () {
    var selectedIds = [];

    var aId = $('#assessmentId').text();
    var sId = $('#scanId').text();
    var hId = $('#hostId').text();

    var vulnerabilitiesDatatable = $('#hostVulnerabilitiesDatatable').DataTable({
        "language": {
            "processing": "Loading data...",
        },
        "stateSave": true,
        "pageLength": 25,
        "lengthMenu": [0, 5, 10, 25, 50, 100, 200, 500],
        "select": true,
        "searching": false,
        "scrollX": true,
        "autoWidth": true,
        "processing": true,
        "serverSide": true,
        "filter": true,
        "ajax": {
            "url": "/api/hostVulnerability",
            "type": "POST",
            "datatype": "json",
            "data": {
                assessmentId: aId,
                scanId: sId,
                hostId: hId
            }
        },
        "columnDefs": [
            { "targets": [0], "orderable": false, "searchable": false },
            { "targets": [1, 5], "searchable": false, "visible": false, "orderable": false },
            {
                "targets": ['_all'],
                render: function (data, type, row) {
                    if (data) {
                        return type === 'display' && data.length > 100 ?
                            data.substr(0, 100) + '…' :
                            data;
                    }
                    else {
                        return " ";
                    }
                }
            }
        ],
        "columns": [
            {
                "render": function (data, type, row, meta) {
                    return `<a href="./View?id=` + row.id + `" type="button" class="btn btn-secondary btn-sm" title="View"><span class="far fa-eye"></span></a>
`;
                }
            },
            { "data": "hostId", "name": "Host ID", "visible": false },
            { "data": "hostName", "name": "Host Name" },
            { "data": "ip", "name": "IP Sort Value" },
            { "data": "operatingSystem", "name": "Operating System" },
            { "data": "id", "name": "Vulnerability ID" },
            { "data": "pluginId", "name": "Plugin ID" },
            { "data": "pluginName", "name": "Plugin Name" },
            { "data": "severity", "name": "Severity Number" },
            { "data": "port", "name": "Port" },
            { "data": "protocol", "name": "Protocol" },
            { "data": "serviceName", "name": "Service Name" },
            { "data": "description", "name": "Description" },
            { "data": "solution", "name": "Solution" },
            { "data": "notes", "name": "Notes" },
            { "data": "vulnerabilityPublicationDate", "name": "Vulnerability Publication Date" },
            { "data": "patchPublicationDate", "name": "Patch Publication Date" },
            { "data": "moreInformation", "name": "More Information" },
            { "data": "scanTool", "name": "Scan Tool" },
            { "data": "riskFactor", "name": "Risk Factor" },
            { "data": "vprScore", "name": "VPR Score" },
            { "data": "cvss3Vector", "name": "CVSSv3 Vector" },
            { "data": "cvss3TemporalVector", "name": "CVSSv3 Temporal Vector" },
            { "data": "cvss3BaseScore", "name": "CVSSv3 Base Score" },
            { "data": "cvss3TemporalScore", "name": "CVSSv3 Temporal Score" },
            { "data": "cvss2Vector", "name": "CVSSv2 Vector" },
            { "data": "cvss2TemporalVector", "name": "CVSSv2 Temporal Vector" },
            { "data": "cvss2BaseScore", "name": "CVSSv2 Base Score" },
            { "data": "cvss2TemporalScore", "name": "CVSSv2 Temporal Score" },
            { "data": "stigSeverity", "name": "STIG Severity" },
            { "data": "cveNumbers", "name": "CVE Numbers" },
            { "data": "bidNumbers", "name": "BID Numbers" },
            { "data": "osvdbNumbers", "name": "OSVDB Numbers" },
            { "data": "inTheNews", "name": "In the News" },
            { "data": "pluginOutput", "name": "Plugin Output" },
            { "data": "pluginFamily", "name": "Plugin Family" },
            { "data": "pluginType", "name": "Plugin Type" },
            { "data": "pluginVersion", "name": "Plugin Version" },
            { "data": "pluginPublicationDate", "name": "Plugin Publication Date" },
            { "data": "pluginModificationDate", "name": "Plugin Modification Date" },
            { "data": "complianceInfo", "name": "Compliance Info" },
            { "data": "complianceResult", "name": "Compliance Result" },
            { "data": "complianceActualValue", "name": "Compliance Actual Value" },
            { "data": "complianceCheckName", "name": "Compliance Check Name" },
            { "data": "complianceCheckId", "name": "Compliance Check ID" },
            { "data": "complianceAuditFile", "name": "Compliance Audit File" },
            { "data": "compliancePolicyValue", "name": "Compliance Policy Value" },
            { "data": "complianceSolution", "name": "Compliance Solution" },
            { "data": "complianceReference", "name": "Compliance Reference" },
            { "data": "complianceMoreInformation", "name": "Compliance More Information" },
            { "data": "exploitedByNessus", "name": "Exploited by Nessus" },
            { "data": "exploitedByMalware", "name": "Exploited by Malware" },
            { "data": "exploitFrameworkCore", "name": "Exploit Framework Core" },
            { "data": "exploitAvailable", "name": "Exploit Available" },
            { "data": "exploitabilityEase", "name": "Exploitability Ease" },
            { "data": "exploitFrameworkMetasploit", "name": "Exploit Framework Metasploit" },
            { "data": "metasploitName", "name": "Metasploit Name" },
            { "data": "exploitFrameworkCanvas", "name": "Exploit Framework Canvas" },
            { "data": "canvasPackage", "name": "Canvas Package" },
            { "data": "path", "name": "Path" },
            { "data": "location", "name": "Location" },
            { "data": "request", "name": "Request" },
            { "data": "response", "name": "Response" },
            { "data": "responseDisplay", "name": "Response Display" },
            { "data": "remediationBackground", "name": "Remediation Background" },
            { "data": "remediationDetail", "name": "Remediation Detail" },
            { "data": "issueBackground", "name": "Issue Background" },
            { "data": "issueDetail", "name": "Issue Detail" },
            { "data": "serialNumber", "name": "Serial Number" },
            { "data": "issueType", "name": "Issue Type" },
            { "data": "issueName", "name": "Issue Name" },
            { "data": "vulnerabilityClassifications", "name": "Vulnerability Classifications" },
        ]
    });

    /*
     * Show/hide columns
     * */
    $('button.toggle-vis').on('click', function (e) {
        e.preventDefault();

        // Get the column API object
        var column = vulnerabilitiesDatatable.column($(this).attr('data-column'));

        // Toggle the visibility
        column.visible(!column.visible());
    });

    $('input.toogle-column-visibility').on('click', function (e) {
        var column = vulnerabilitiesDatatable.column($(this).attr('data-column'));
        // Toggle the visibility
        column.visible(!column.visible());
    });

    $('button.toogle-column-visibility-select-special').on('click', function (e) {
        if (this.id === "customSwitchShowAll") {
            showAllColumns();
        }
        else if (this.id === "customSwitchHideAll") {
            hideAllColumns();
        }
    });

    /*
     * Set correct state on visibility switches when modul loads
     * */
    $('a.show-hide-columns').on('click', function (e) {
        setCorrectSwitchStates();
    });

    function setCorrectSwitchStates() {
        var allCheckboxes = document.getElementsByClassName("toogle-column-visibility");

        for (let i = 0; i < allCheckboxes.length; i++) {
            var column = vulnerabilitiesDatatable.column($(allCheckboxes[i]).attr('data-column'));
            var isVisible = column.visible();
            if (isVisible == true) {
                allCheckboxes[i].checked = true;
            }
            else {
                allCheckboxes[i].checked = false;
            }
        }
    }

    function showAllColumns() {
        vulnerabilitiesDatatable.columns().visible(true);
        var allCheckboxes = document.getElementsByClassName("toogle-column-visibility");
        vulnerabilitiesDatatable.columns([1, 5]).visible(false); //Exceptions, always hide these columns
        for (let i = 0; i < allCheckboxes.length; i++) {
            allCheckboxes[i].checked = true;
        }
    }

    function hideAllColumns() {
        vulnerabilitiesDatatable.columns().visible(false);
        vulnerabilitiesDatatable.columns([0]).visible(true); //Exceptions, always display this columns
        var allCheckboxes = document.getElementsByClassName("toogle-column-visibility");

        for (let i = 0; i < allCheckboxes.length; i++) {
            allCheckboxes[i].checked = false;
        }
    }

});